// SPW.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "SPW.h"
#include "StaticLink.h"

#include "MainFrm.h"
#include "SPWDoc.h"
#include "SPWListView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static BOOL bClassRegistered = FALSE;

/////////////////////////////////////////////////////////////////////////////
// CSPWApp

BEGIN_MESSAGE_MAP(CSPWApp, CWinApp)
	//{{AFX_MSG_MAP(CSPWApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSPWApp construction

CSPWApp::CSPWApp()
{
	m_strSection = _T("Settings");
	m_strProjectDirKey = _T("ProjectDir");
	
	m_strRfxDateKey = _T("RfxDate");
	m_strRfxTimeKey = _T("RfxTime");
	m_strRfxTimeStampKey = _T("RfxTimeStamp");
	m_strSSP = _T("ShowSP");

	m_strInitialDir = _T("Initial_Dir");
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CSPWApp object

CSPWApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CSPWApp initialization

BOOL CSPWApp::InitInstance()
{
	CWaitCursor wait;

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("George Poulose"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CSPWDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CSPWListView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if(!ProcessShellCommand(cmdInfo))
		return FALSE;
		
	((CMainFrame*)m_pMainWnd)->InitialShowWindow(SW_SHOWNORMAL);
	((CMainFrame*)m_pMainWnd)->OnFileConnect();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	void InsertODBCInfo();
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CListCtrlEx	m_ListCtrlODBCInfo;
	CStatic	m_staticText;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	UINT m_uTimerID;
	UINT m_nBitmapID;
	CBitmap m_bitmap;

	COLORREF m_colorUnvisited;
	COLORREF m_colorVisited;
	BOOL m_bVisited;

	CStaticLink m_staticLink;
	CFont m_font;

	virtual BOOL OnInitDialog();
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT

	m_colorUnvisited = RGB(0, 0, 255);	 // blue
	m_colorVisited   = RGB(128, 0, 128); // purple
	m_bVisited       = FALSE;
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_ODBC_INFO, m_ListCtrlODBCInfo);
	DDX_Control(pDX, IDC_URL_TEXT, m_staticText);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_TIMER()
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CSPWApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CSPWApp commands

BOOL CAboutDlg::OnInitDialog()
{
	CWaitCursor wait;
	
	CDialog::OnInitDialog();	// CG:  This was added by System Info Component.
	
	m_ListCtrlODBCInfo.SetFullRowSel(TRUE);
	
	m_nBitmapID = IDB_BITMAP1;
	m_uTimerID = SetTimer(1, 10, NULL);

	CRect rect;
	m_staticText.GetWindowRect(&rect);
	ScreenToClient(&rect);
	
	if(!m_staticLink.Create("", WS_CHILD | WS_VISIBLE, rect, this, 0))
		TRACE("Failed to create static link.\n");

	InsertODBCInfo();

	UpdateData(FALSE);

	return TRUE;	// CG:  This was added by System Info Component.
}

void CAboutDlg::OnTimer(UINT nIDEvent) 
{
	if(m_uTimerID != nIDEvent) // not our timer
		CDialog::OnTimer(nIDEvent);
	else
	{
		KillTimer(m_uTimerID); // kill one-shot timer
		
		m_uTimerID = 0;
		
		CStatic* pStatic = (CStatic*)GetDlgItem(IDC_STATIC_BITMAP);
		
		if((HBITMAP)m_bitmap.m_hObject != NULL)
			m_bitmap.DeleteObject();

		m_bitmap.LoadBitmap(m_nBitmapID);
		
		if(pStatic)
		{
			pStatic->SetBitmap((HBITMAP)m_bitmap.m_hObject);
			m_uTimerID = SetTimer(1, 150, NULL);
			m_nBitmapID++;

			if(m_nBitmapID > IDB_BITMAP18)
				m_nBitmapID = IDB_BITMAP1; // Force the Earth to rotate
		}
	}
}

HBRUSH CAboutDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	if(pWnd == &m_staticText)
	{
		if(!(HFONT)m_font)
		{
			LOGFONT lf;
			GetFont()->GetObject(sizeof(lf), &lf);
			lf.lfUnderline = TRUE;
			m_font.CreateFontIndirect(&lf);
			pWnd->SetFont(&m_font);
		}
		
		pDC->SelectObject(&m_font);
		pDC->SetTextColor(m_staticLink.m_bVisited ? m_colorVisited : m_colorUnvisited);
		pDC->SetBkMode(TRANSPARENT);
				
		hbr = (HBRUSH)::GetStockObject(HOLLOW_BRUSH);
	}

	return hbr;
}

void CAboutDlg::InsertODBCInfo()
{
	LV_COLUMN lvcColumn;
	lvcColumn.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	lvcColumn.fmt = LVCFMT_LEFT;
	int nColumn = 0;

	lvcColumn.cx = 100;
	lvcColumn.pszText = "Driver Name";
	lvcColumn.iSubItem = nColumn++;
	m_ListCtrlODBCInfo.InsertColumn(0, &lvcColumn );
	
	lvcColumn.cx = 94;
	lvcColumn.pszText = "Driver Version";
	lvcColumn.iSubItem = nColumn++;
	m_ListCtrlODBCInfo.InsertColumn(1, &lvcColumn );

	lvcColumn.cx = 90;
	lvcColumn.pszText = "ODBC Version";
	lvcColumn.iSubItem = nColumn++;
	m_ListCtrlODBCInfo.InsertColumn(2, &lvcColumn);

	HDBC hDBC = ((CSPWDoc*)((CMainFrame*)AfxGetMainWnd())->GetActiveDocument())->m_database.m_hdbc;
	
	if(hDBC == NULL)
		m_ListCtrlODBCInfo.InsertItem(0, "<CDatabase::m_hdbc == NULL>");	
	else
	{
		UCHAR buffer[200];
		SWORD cbData;
			
		// Driver Name
		CString strSqlDriverName;
		::SQLGetInfo(hDBC, SQL_DRIVER_NAME, (PTR)buffer, 200, &cbData);
		strSqlDriverName = buffer;

		// Driver Version
		CString strSqlDriverVer;
		::SQLGetInfo(hDBC, SQL_DRIVER_VER, (PTR)buffer, 200, &cbData);
		strSqlDriverVer = buffer;

		// ODBC Version
		CString	strSqlDriverOdbcVer;
		::SQLGetInfo(hDBC, SQL_ODBC_VER, (PTR)buffer, 200, &cbData);
		strSqlDriverOdbcVer = buffer;

		CString sRow = strSqlDriverName + "\t" + strSqlDriverVer + "\t" + strSqlDriverOdbcVer + "\t";

		LV_ITEM lvItem;
		int iItemIndex;
		CString sColVal;
		
		int nEnd = sRow.Find("\t");
		
		if(nEnd != -1)
		{
			int i 			= 0;
			lvItem.mask 	= LVIF_TEXT;
			lvItem.iItem 	= 0;
			lvItem.iSubItem = i++;
			sColVal 		= sRow.Mid(0, nEnd);
			lvItem.pszText 	= sColVal.GetBuffer(sColVal.GetLength()+1);
			sColVal.ReleaseBuffer();

			iItemIndex 	= m_ListCtrlODBCInfo.InsertItem(&lvItem);

			if(iItemIndex != -1)
			{
				while(sRow.GetLength() > nEnd) 
				{  		
					sRow = sRow.Mid(nEnd + 1);
					nEnd = sRow.Find("\t");
					
					if(nEnd == -1)
						break;
					
					lvItem.iItem = iItemIndex;
					lvItem.iSubItem = i++;
					sColVal = sRow.Mid(0, nEnd);
					lvItem.pszText = sColVal.GetBuffer(sColVal.GetLength()+1);
					sColVal.ReleaseBuffer();
							
					m_ListCtrlODBCInfo.SetItem(&lvItem);
				}
			}
		}
	}
}